config/routes.rb
Rails.application.routes.draw do
  resources :measurements

  resources :quantities, except: [:show], path_names: {new: '(/:id)/new'} do
    member { post :reparent }
  end

  resources :units, except: [:show], path_names: {new: '(/:id)/new'} do
    member { post :rebase }
  end

  namespace :default do
    resources :units, only: [:index, :destroy] do
      member { post :import, :export }
      #collection { post :import_all }
    end
  end

  devise_for :users, path: '', path_names: {registration: 'profile'},
    controllers: {registrations: :registrations}
  resources :users, only: [:index, :show, :update] do
    member { get :disguise }
    collection { get :revert }
  end

  unauthenticated do
    as :user do
      root to: redirect('/sign_in')
    end
  end
  root to: redirect('/units'), as: :user_root

  direct(:source_code) { 'https://gitea.michalczyk.pro/fixin.me/fixin.me' }
  direct(:issue_tracker) { 'https://gitea.michalczyk.pro/fixin.me/fixin.me/issues' }
end

app/models/user.rb
class User < ApplicationRecord
  devise :database_authenticatable, :registerable, :confirmable,
         :recoverable, :rememberable, :validatable

  # Statuses ordered by decreasing privileges
  enum :status, {
    admin: 4,       # admin level access
    active: 3,      # read-write user level access
    restricted: 2,  # read-only user level access
    locked: 1,      # disallowed to sign in due to failed logins; maintained by Devise :lockable
    disabled: 0,    # administratively disallowed to sign in
  }, default: :active

  has_many :readouts, dependent: :destroy
  accepts_nested_attributes_for :readouts
  has_many :quantities, dependent: :destroy
  has_many :units, dependent: :destroy

  validates :email, presence: true, uniqueness: true,
    length: {maximum: type_for_attribute(:email).limit}
  validates :unconfirmed_email, length: {maximum: type_for_attribute(:unconfirmed_email).limit}

  def to_s
    email
  end

  def at_least(status)
    User.statuses[self.status] >= User.statuses[status]
  end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  helper_method :allow_disguise?

  before_action :find_user, only: [:show, :update, :disguise]

  before_action only: :revert do
    raise AccessForbidden unless current_user_disguised?
  end
  before_action except: :revert do
    raise AccessForbidden unless current_user.at_least(:admin)
  end

  def index
    @users = User.all
  end

  def show
  end

  def update
    raise ParameterInvalid if current_user == @user
    @user.update!(params.require(:user).permit(:status))
  end

  def disguise
    raise ParameterInvalid unless allow_disguise?(@user)
    session[:revert_to_id] = current_user.id
    bypass_sign_in(@user)
    redirect_to root_url
  end

  def revert
    @user = User.find(session.delete(:revert_to_id))
    bypass_sign_in(@user)
    redirect_to users_url
  end

  # NOTE: limited actions availabe to :admin by design. Users are meant to
  # manage their accounts by themselves through registrations. :admin
  # is allowed to sign-in (disguise) as user and make changes from there.

  protected

  def allow_disguise?(user)
    user&.confirmed? && (user != current_user) && !current_user_disguised?
  end

  private

  def find_user
    @user = User.find(params[:id])
  end
end

app/helpers/users_helper.rb
module UsersHelper
end

app/views/users/index.html.erb
<table class="main items" id="users">
  <thead>
    <tr>
      <th><%= User.human_attribute_name(:email).capitalize %></th>
      <th><%= User.human_attribute_name(:status).capitalize %></th>
      <th><%= User.human_attribute_name(:confirmed_at).capitalize %></th>
      <th><%= User.human_attribute_name(:created_at).capitalize %>&nbsp;<sup>UTC</sup></th>
      <th><%= t :actions %></th>
    </tr>
  </thead>
  <tbody>
    <% @users.each do |user| %>
      <tr>
        <td class="link"><%= link_to user, user_path(user) %></td>
        <td>
          <% if user == current_user %>
            <%= user.status %>
          <% else %>
            <%= form_for user do |u| %>
              <%= u.select :status, User.statuses.keys, {}, autocomplete: "off",
                onchange: "this.form.requestSubmit();" %>
            <% end %>
          <% end %>
        </td>
      <td class="svg">
        <%= svg_tag "pictograms/checkbox-marked-outline" if user.confirmed_at.present? %>
      </td>
      <td><%= user.created_at.to_fs(:db_without_sec) %></td>
      <td class="actions">
        <% if allow_disguise?(user) %>
          <%= image_link_to t(".disguise"), "incognito", disguise_user_path(user) %>
        <% end %>
      </td>
      </tr>
    <% end %>
  </tbody>
</table>

app/views/users/show.html.erb
<% content_for :navigation, flush: true do %>
  <div class="left">
    <%= image_link_to t(:back), "arrow-left-bold-outline", users_path %>
  </div>
<% end %>

<%= labelled_form_for @user do |f| %>
  <%= f.email_field :email, readonly: true %>
  <% if f.object.pending_reconfirmation? %>
    <%= f.email_field :unconfirmed_email, readonly: true,
      hint: t("users.registrations.edit.unconfirmed_email_hint",
              timestamp: f.object.confirmation_sent_at.to_fs(:db_without_sec)) %>
  <% end %>

  <%= f.select :status, User.statuses, readonly: true %>

  <%= f.text_field :created_at, readonly: true %>
  <%= f.text_field :confirmed_at, readonly: true %>
<% end %>